#pragma semicolon 1

#include <sourcemod>
#include <sdktools>
#include <cstrike>
#include <geoip>
#include <sdkhooks>

#define MAX_ENTS 1111

public Plugin:myinfo = 
{
	name = "More_ES_Commands",
	author = "wS / World-Source.Ru",
	description = "SourceMod commands for EventScripts",
	version = "1.4.2",
	url = "http://world-source.ru/"
};

new PrecH, PrecB;

new const String:AdminFlagName[21][] = 
{
	"RESERVATION",
	"GENERIC",
	"KICK",
	"BAN",
	"UNBAN",
	"SLAY",
	"CHANGEMAP",
	"CONVARS",
	"CONFIG",
	"CHAT",
	"VOTE",
	"PASSWORD",
	"RCON",
	"CHEATS",
	"ROOT",
	"CUSTOM1",
	"CUSTOM2",
	"CUSTOM3",
	"CUSTOM4",
	"CUSTOM5",
	"CUSTOM6"
};

new const AdminFlagBit[21] = 
{
	(1 << 0),
	(1 << 1),
	(1 << 2),
	(1 << 3),
	(1 << 4),
	(1 << 5),
	(1 << 6),
	(1 << 7),
	(1 << 8),
	(1 << 9),
	(1 << 10),
	(1 << 11),
	(1 << 12),
	(1 << 13),
	(1 << 14),
	(1 << 15),
	(1 << 16),
	(1 << 17),
	(1 << 18),
	(1 << 19),
	(1 << 20)
};

new TransmitEntityClientsNum[MAX_ENTS+1];
new bool:IndexHiddenForClient[MAX_ENTS+1][MAXPLAYERS+1];
new SDKHooksStatus;

public OnPluginStart()
{
	ServerCommand("es_xloadevents declare resource/ES_Commands_Events.res");

	RegServerCmd("eSetPlayerTeam",			eSetPlayerTeam,			"eSetPlayerTeam <userid> <team>");
	RegServerCmd("eSetPlayerDeaths",		eSetPlayerDeaths,		"eSetPlayerDeaths <userid> <value>");
	RegServerCmd("eSetTeamScore",			eSetTeamScore,			"eSetTeamScore <team> <score>");
	RegServerCmd("eSetPlayerClanTag",		eSetPlayerClanTag,		"eSetPlayerClanTag <userid> [tag]");
	RegServerCmd("eSetCvarNotify",			eSetCvarNotify,			"eSetCvarNotify <server_var> <1=yes|0=no>");
	RegServerCmd("eGetPlayerWeaponSlot",	eGetPlayerWeaponSlot,	"eGetPlayerWeaponSlot <userid> <slot 0-4> <var_index> [var_classname]");
	RegServerCmd("eGetPlayerClanTag",		eGetPlayerClanTag,		"eGetPlayerClanTag <var> <userid>");
	RegServerCmd("eGetTeamScore",			eGetTeamScore,			"eGetTeamScore <var> <team>");
	RegServerCmd("eGetPlayerLookIndex",		eGetPlayerLookIndex,	"eGetPlayerLookIndex <userid> <var_index> [var_origin]");
	RegServerCmd("eGetUseridFromIndex",		eGetUseridFromIndex,	"eGetUseridFromIndex <var> <player_index>");
	RegServerCmd("eSlapPlayer",				eSlapPlayer,			"eSlapPlayer <userid> <hp> [1 = nosound]");
	RegServerCmd("eForcePlayerDrop",		eForcePlayerDrop,		"eForcePlayerDrop <userid> <weapon_index>");
	RegServerCmd("eTerminateRound",			eTerminateRound,		"eTerminateRound <seconds> <reason 0-15>");
	RegServerCmd("eHookEntityOutput",		wS_Output,				"eHookEntityOutput <index|classname> <output_string>");
	RegServerCmd("eUnHookEntityOutput",		wS_Output,				"eUnHookEntityOutput <index|classname> <output_string>");
	RegServerCmd("eRotateEntity",			eRotateEntity,			"eRotateEntity <entity_index> <degree 1-180>");
	RegServerCmd("eRingEffect",				eRingEffect,			"eRingEffect <vec_center> <radius_start> <radius_end> <life> <width> <amplitude> \"r,g,b,a\" [speed] [model_index] [halo_index]");
	RegServerCmd("eRespawnPlayer",			eRespawnPlayer,			"eRespawnPlayer <userid>");
	RegServerCmd("eGetPlayerCountry",		eGetPlayerCountry,		"eGetPlayerCountry <var> <userid>");
	RegServerCmd("eGetSmAdminFlag",			eGetSmAdminFlag,		"eGetSmAdminFlag <var> <userid> <flag>");
	RegServerCmd("eGetSmPluginsList",		eGetSmPluginsList,		"eGetSmPluginsList");
	RegServerCmd("eGetSmPluginStatus",		eGetSmPluginStatus,		"eGetSmPluginStatus <var> <plugin.smx>");
	RegServerCmd("eHookConVarChange",		eHookConVar,			"eHookConVarChange <server_var>");
	RegServerCmd("eUnhookConVarChange",		eHookConVar,			"eUnhookConVarChange <server_var>");
	RegServerCmd("eHideEntityFromPlayer",	eHideEntityFromPlayer,	"eHideEntityFromPlayer <userid> <entity_index> <1=hide|0>");
	RegServerCmd("eUnHideEntity",			eUnHideEntity,			"eUnHideEntity <entity_index>");
	RegServerCmd("eHookStartTouch",			eStartTouch,			"eHookStartTouch <entity_index>");
	RegServerCmd("eUnHookStartTouch",		eStartTouch,			"eUnHookStartTouch <entity_index>");
}

public OnMapStart()
{
	ServerCommand("es_xloadevents resource/ES_Commands_Events.res");
	PrecH = PrecacheModel("materials/sprites/halo01.vmt", true);
	PrecB = PrecacheModel("materials/sprites/laser.vmt", true);
	CreateConVar("More_ES_Commands", "1.4.2", "More_ES_Commands version [ Plugin by World-Source.Ru ]", FCVAR_NOTIFY);
}

public OnConfigsExecuted()
{
	SDKHooksStatus = GetExtensionFileStatus("sdkhooks.ext");
}

public Action:eSetPlayerTeam(args)
{
	if (GoodArgs(args, 2, "eSetPlayerTeam <userid> <team>"))
	{
		new client = GetClientFromArgNum(1);
		if (client > 0)
		{
			new team = GetIntFromArgNum(2);
			if (0 < team < 4 && team != GetClientTeam(client))
			{
				if (team == 1) ChangeClientTeam(client, 1);
				else CS_SwitchTeam(client, team);
			}
		}
	}
	return Plugin_Handled;
}

public Action:eSetPlayerDeaths(args)
{
	if (GoodArgs(args, 2, "eSetPlayerDeaths <userid> <value>"))
	{
		new client = GetClientFromArgNum(1);
		if (client > 0) SetEntProp(client, Prop_Data, "m_iDeaths", GetIntFromArgNum(2));
	}
	return Plugin_Handled;
}

public Action:eSetTeamScore(args)
{
	if (GoodArgs(args, 2, "eSetTeamScore <team> <score>"))
	{
		new team = GetIntFromArgNum(1);
		if (team == 2 || team == 3) SetTeamScore(team, GetIntFromArgNum(2));
	}
	return Plugin_Handled;
}

public Action:eSetCvarNotify(args)
{
	if (GoodArgs(args, 2, "eSetCvarNotify <server_var> <1=yes|0=no>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "", true);
		if (var != INVALID_HANDLE)
		{
			if (GetIntFromArgNum(2) == 1) SetConVarFlags(var, GetConVarFlags(var) | FCVAR_NOTIFY);
			else SetConVarFlags(var, GetConVarFlags(var) & ~FCVAR_NOTIFY);
		}
	}
	return Plugin_Handled;
}

public Action:eSetPlayerClanTag(args)
{
	if (args != 1 && args != 2)
	{
		LogError("Syntax: eSetPlayerClanTag <userid> [tag]");
		return Plugin_Handled;
	}
	new client = GetClientFromArgNum(1);
	if (client > 0)
	{
		if (args == 1) CS_SetClientClanTag(client, "");
		else
		{
			decl String:tag[75];
			tag[0] = '\0';
			GetCmdArg(2, tag, 75);
			CS_SetClientClanTag(client, tag);
		}
	}
	return Plugin_Handled;
}

public Action:eGetPlayerWeaponSlot(args)
{
	if (args != 3 && args != 4)
	{
		LogError("Syntax: eGetPlayerWeaponSlot <userid> <slot 0-4> <var_index> [var_classname]");
		return Plugin_Handled;
	}
	new Handle:var_index = GetVarHandleFromArgNum(3, "0");
	if (var_index != INVALID_HANDLE)
	{
		new client = GetClientFromArgNum(1);
		new slot = GetIntFromArgNum(2);
		if (client > 0 && -1 < slot < 5)
		{
			new index = GetPlayerWeaponSlot(client, slot);
			SetConVarInt(var_index, index);
			if (args > 3)
			{
				new Handle:var_classname = GetVarHandleFromArgNum(4);
				if (var_classname != INVALID_HANDLE)
				{
					decl String:classname[55];
					if (GetEntityClassname(index, classname, 55)) SetConVarString(var_classname, classname);
					else SetConVarString(var_classname, "");
				}
			}
		}
		else SetConVarInt(var_index, -1);
	}
	return Plugin_Handled;
}

public Action:eGetPlayerClanTag(args)
{
	if (GoodArgs(args, 2, "eGetPlayerClanTag <var> <userid>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1);
		if (var != INVALID_HANDLE)
		{
			new client = GetClientFromArgNum(2);
			if (client > 0)
			{
				decl String:tag[75];
				tag[0] = '\0';
				CS_GetClientClanTag(client, tag, 75);
				SetConVarString(var, tag);
			}
			else SetConVarString(var, "");
		}
	}
	return Plugin_Handled;
}

public Action:eGetTeamScore(args)
{
	if (GoodArgs(args, 2, "eGetTeamScore <var> <team>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "0");
		if (var != INVALID_HANDLE)
		{
			new team = GetIntFromArgNum(2);
			if (team == 2 || team == 3) SetConVarInt(var, GetTeamScore(team));
			else SetConVarInt(var, 0);
		}
	}
	return Plugin_Handled;
}

public Action:eGetPlayerLookIndex(args)
{
	if (args != 2 && args != 3)
	{
		LogError("Syntax: eGetPlayerLookIndex <userid> <var_index> [var_origin]");
		return Plugin_Handled;
	}
	new Handle:var_index = GetVarHandleFromArgNum(2, "-1");
	if (var_index != INVALID_HANDLE)
	{
		new client = GetClientFromArgNum(1);
		if (client > 0)
		{
			decl Float:Position[3], Float:Angles[3];
			GetClientEyePosition(client, Position);
			GetClientEyeAngles(client, Angles);
			TR_TraceRayFilter(Position, Angles, MASK_SOLID, RayType_Infinite, wS_TraceFilter, client);
			new index = TR_GetEntityIndex();
			SetConVarInt(var_index, index);
			if (index > -1 && args == 3)
			{
				new Handle:var_origin = GetVarHandleFromArgNum(3);
				if (var_origin != INVALID_HANDLE)
				{
					TR_GetEndPosition(Position);
					decl String:str_origin[75];
					Format(str_origin, 75, "%f %f %f", Position[0], Position[1], Position[2]);
					SetConVarString(var_origin, str_origin);
				}
			}
		}
		else SetConVarInt(var_index, -1);
	}
	return Plugin_Handled;
}

public bool:wS_TraceFilter(ent, mask, any:client) return client != ent;

public Action:eGetUseridFromIndex(args)
{
	if (GoodArgs(args, 2, "eGetUseridFromIndex <var> <player_index>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "0");
		if (var != INVALID_HANDLE)
		{
			new client = GetIntFromArgNum(2);
			if (client > 0 && client <= MaxClients && IsClientInGame(client)) SetConVarInt(var, GetClientUserId(client));
			else SetConVarInt(var, 0);
		}
	}
	return Plugin_Handled;
}

public Action:eSlapPlayer(args)
{
	if (args != 2 && args != 3)
	{
		LogError("Syntax: eSlapPlayer <userid> <hp> [1 = nosound]");
		return Plugin_Handled;
	}
	new client = GetClientFromArgNum(1);
	if (client > 0)
	{
		new hp = GetIntFromArgNum(2);
		if (args == 2) SlapPlayer(client, hp, true);
		else SlapPlayer(client, hp, false);
	}
	return Plugin_Handled;
}

public Action:eForcePlayerDrop(args)
{
	if (GoodArgs(args, 2, "eForcePlayerDrop <userid> <weapon_index>"))
	{
		new client = GetClientFromArgNum(1);
		if (client > 0) CS_DropWeapon(client, GetIntFromArgNum(2), true, false);
	}
	return Plugin_Handled;
}

public Action:eTerminateRound(args)
{
	if (GoodArgs(args, 2, "eTerminateRound <seconds> <reason 0-15>"))
	{
		new sec = GetIntFromArgNum(1);
		new rsn = GetIntFromArgNum(2);
		if (sec < 0 || sec > 30) sec = 5;
		if (rsn < 0 || rsn > 15) rsn = 9;
		CS_TerminateRound(float(sec), CSRoundEndReason:rsn);
	}
	return Plugin_Handled;
}

/// eHookEntityOutput|eUnHookEntityOutput <index|classname> <output_string>

public Action:wS_Output(args)
{
	decl String:Hook_CmD[25];
	GetCmdArg(0, Hook_CmD, 25);
	if (args != 2)
	{
		LogError("Syntax: %s <index|classname> <output_string>", Hook_CmD);
		return Plugin_Handled;
	}
	new bool:its_hook = StrEqual(Hook_CmD, "eHookEntityOutput", false);
	decl String:Ent_Typ[55], String:Output_String[85];
	GetCmdArg(1, Ent_Typ, 55);
	GetCmdArg(2, Output_String, 85);
	new Ent_Index = StringToInt(Ent_Typ);
	if (Ent_Index > 0)
	{
		if (!IsValidEntity(Ent_Index)) LogError("%s: Bad index < %d >", Hook_CmD, Ent_Index);
		else if (its_hook) HookSingleEntityOutput(Ent_Index, Output_String, EntityOutput:Entity_Output_Func);
		else UnhookSingleEntityOutput(Ent_Index, Output_String, EntityOutput:Entity_Output_Func);
	}
	else if (its_hook) HookEntityOutput(Ent_Typ, Output_String, EntityOutput:Entity_Output_Func);
	else UnhookEntityOutput(Ent_Typ, Output_String, EntityOutput:Entity_Output_Func);
	return Plugin_Handled;
}

public Entity_Output_Func(const String:output[], ent, client, Float:delay)
{
	new Handle:event = CreateEvent("es_entity_output");
	if (event == INVALID_HANDLE)
	{
		LogError("es_entity_output INVALID_HANDLE");
		return;
	}
	decl String:classname[55];
	classname[0] = '\0';
	GetEntityClassname(ent, classname, 55);
	SetEventString(event, "entity_class", classname);
	SetEventString(event, "output", output);
	SetEventInt(event, "entity_index", ent);
	if (client > 0 && client <= MaxClients && IsClientInGame(client)) SetEventInt(event, "userid", GetClientUserId(client));
	else SetEventInt(event, "userid", 0);
	FireEvent(event);
}

/// event player_drop

public Action:CS_OnCSWeaponDrop(client, weapon_index)
{
	new Handle:event = CreateEvent("player_drop");
	if (event == INVALID_HANDLE)
	{
		LogError("player_drop INVALID_HANDLE");
		return Plugin_Continue;
	}
	decl String:wS_Weapon[32];
	wS_Weapon[0] = '\0';
	GetEntityClassname(weapon_index, wS_Weapon, 32);
	SetEventString(event, "weapon_class", wS_Weapon);
	if (!IsClientInGame(client)) SetEventInt(event, "userid", 0);
	else SetEventInt(event, "userid", GetClientUserId(client));
	SetEventInt(event, "weapon_index", weapon_index);
	FireEvent(event);
	return Plugin_Continue;
}

/// eRotateEntity <entity_index> <degree>

public Action:eRotateEntity(args)
{
	if (!GoodArgs(args, 2, "eRotateEntity <entity_index> <degree 1-180>"))
	{
		return Plugin_Handled;
	}
	new entity_index = GetIntFromArgNum(1);
	if (entity_index < 1 || !IsValidEntity(entity_index))
	{
		LogError("eRotateEntity: invalid entity_index < %d >", entity_index);
		return Plugin_Handled;
	}
	new Float:degree = float(GetIntFromArgNum(2));
	if (degree < 1.0 || degree > 180.0) degree = 45.0;
	decl Float:angles[3], Float:normal[3], Float:direction[3];
	GetEntPropVector(entity_index, Prop_Send, "m_angRotation", angles);
	GetAngleVectors(angles, direction, NULL_VECTOR, normal);
	new Float:sin = Sine(degree * 0.01745328);
	new Float:cos = Cosine(degree * 0.01745328);
	new Float:a = normal[0] * sin;
	new Float:b = normal[1] * sin;
	new Float:c = normal[2] * sin;
	new Float:x = direction[2] * b + direction[0] * cos - direction[1] * c;
	new Float:y = direction[0] * c + direction[1] * cos - direction[2] * a;
	new Float:z = direction[1] * a + direction[2] * cos - direction[0] * b;
	direction[0] = x;
	direction[1] = y;
	direction[2] = z;
	GetVectorAngles(direction, angles);
	decl Float:up[3];
	GetVectorVectors(direction, NULL_VECTOR, up);
	new Float:roll = GetAngleBetweenVectors(up, normal, direction);
	angles[2] += roll;
	TeleportEntity(entity_index, NULL_VECTOR, angles, NULL_VECTOR);
	return Plugin_Handled;
}

Float:GetAngleBetweenVectors(const Float:vector1[3], const Float:vector2[3], const Float:direction[3])
{
	decl Float:vector1_n[3], Float:vector2_n[3], Float:direction_n[3], Float:cross[3];
	NormalizeVector(direction, direction_n);
	NormalizeVector(vector1, vector1_n);
	NormalizeVector(vector2, vector2_n);
	new Float:degree = ArcCosine(GetVectorDotProduct(vector1_n, vector2_n)) * 57.29577951;
	GetVectorCrossProduct(vector1_n, vector2_n, cross);
	if (GetVectorDotProduct(cross, direction_n) < 0.0) degree *= -1.0;
	return degree;
}

/// eRingEffect <vec_center> <radius_start> <radius_end> <life> <width> <amplitude> "r,g,b,a" [speed] [model_index] [halo_index]

public Action:eRingEffect(args)
{
	if (args < 7 || args > 10)
	{
		LogError("Syntax: eRingEffect <vec_center> <radius_start> <radius_end> <life> <width> <amplitude> \"r,g,b,a\" [speed] [model_index] [halo_index]");
		return Plugin_Handled;
	}
	decl String:StR[75], String:ExpStR[4][25];

	// <vec_center>
	GetCmdArg(1, StR, 75);
	if (ExplodeString(StR, ",", ExpStR, 3, 25) != 3)
	{
		LogError("eRingEffect: Bad <vec_center> (syntax: \"x,y,z\")");
		return Plugin_Handled;
	}
	decl Float:vec_center[3];
	for (new i = 0; i < 3; i++) vec_center[i] = StringToFloat(ExpStR[i]);

	// "r,g,b,a"
	GetCmdArg(7, StR, 75);
	if (ExplodeString(StR, ",", ExpStR, 4, 10) != 4)
	{
		LogError("eRingEffect: Bad \"r,g,b,a\"");
		return Plugin_Handled;
	}
	decl color[4];
	new int_value;
	for (new x = 0; x < 4; x++)
	{
		if ((int_value = StringToInt(ExpStR[x])) < 0 || int_value > 255)
		{
			LogError("eRingEffect: Bad \"r,g,b,a\" (%d)", x+1);
			return Plugin_Handled;
		}
		color[x] = int_value;
	}

	// <radius_start>
	GetCmdArg(2, StR, 15);
	new Float:radius_start = StringToFloat(StR);

	// <radius_end>
	GetCmdArg(3, StR, 15);
	new Float:radius_end = StringToFloat(StR);
 
	// <life>
	GetCmdArg(4, StR, 15);
	new Float:life = StringToFloat(StR);
	if (life < 1.0) life = 1.0;

	// <width>
	GetCmdArg(5, StR, 15);
	new Float:width = StringToFloat(StR);
	if (width < 1.0) width = 1.0;

	// <amplitude>
	GetCmdArg(6, StR, 15);
	new Float:amplitude = StringToFloat(StR);
  
	// speed
	new speed;
	if (args > 7)
	{
		GetCmdArg(8, StR, 15);
		if ((speed = StringToInt(StR)) < 1) speed = 1;
	}
	else speed = 1;

	// model_index
	new model_index;
	if (args > 8)
	{
		GetCmdArg(9, StR, 15);
		if ((model_index = StringToInt(StR)) < 1) model_index = PrecB;
	}
	else model_index = PrecB;

	// halo_index
	new halo_index;
	if (args > 9)
	{
		GetCmdArg(10, StR, 15);
		if ((halo_index = StringToInt(StR)) < 1) halo_index = PrecH;
	}
	else halo_index = PrecH;

	TE_SetupBeamRingPoint(vec_center, radius_start, radius_end, model_index, halo_index, 0, 0, life, width, amplitude, color, speed, 0);
	TE_SendToAll();
	return Plugin_Handled;
}

public Action:eRespawnPlayer(args)
{
	if (GoodArgs(args, 1, "eRespawnPlayer <userid>"))
	{
		new client = GetClientFromArgNum(1);
		if (client > 0) CS_RespawnPlayer(client);
	}
	return Plugin_Handled;
}

public Action:eGetPlayerCountry(args)
{
	if (GoodArgs(args, 2, "eGetPlayerCountry <var> <userid>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "unknown");
		if (var != INVALID_HANDLE)
		{
			new client = GetClientFromArgNum(2);
			if (client > 0)
			{
				decl String:IP[25];
				if (GetClientIP(client, IP, 25))
				{
					decl String:Country[45];
					if (GeoipCountry(IP, Country, 45))
					{
						SetConVarString(var, Country);
						return Plugin_Handled;
					}
				}
			}
			SetConVarString(var, "unknown");
		}
	}
	return Plugin_Handled;
}

public Action:eGetSmAdminFlag(args)
{
	if (GoodArgs(args, 3, "eGetSmAdminFlag <var> <userid> <flag>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "0");
		if (var != INVALID_HANDLE)
		{
			new client = GetClientFromArgNum(2);
			if (client > 0)
			{
				new flags = GetUserFlagBits(client);
				if (flags & ADMFLAG_ROOT)
				{
					SetConVarInt(var, 1);
					return Plugin_Handled;
				}
				decl String:str_flag[15];
				GetCmdArg(3, str_flag, 15);
				for (new i = 0; i < 21; i++)
				{
					if (StrEqual(str_flag, AdminFlagName[i]))
					{
						if (flags & AdminFlagBit[i])
						{
							SetConVarInt(var, 1);
							return Plugin_Handled;
						}
						break;
					}
				}
			}
			SetConVarInt(var, 0);
		}
	}
	return Plugin_Handled;
}

public Action:eGetSmPluginsList(args)
{
	if (GoodArgs(args, 0, "eGetSmPluginsList"))
	{
		InsertServerCommand("keygroupremove SmPluginsGroup;es_xkeygroupcreate SmPluginsGroup");
		decl String:plugin_name[125];
		new Handle:iterator = GetPluginIterator(), nuM = 0;
		while (MorePlugins(iterator))
		{
			GetPluginFilename(ReadPlugin(iterator), plugin_name, 125);
			nuM += 1;
			ServerCommand("es_xkeycreate SmPluginsGroup %d;es_xkeysetvalue SmPluginsGroup %d plugin %s", nuM, nuM, plugin_name);
		}
		CloseHandle(iterator);
	}
	return Plugin_Handled;
}

public Action:eGetSmPluginStatus(args)
{
	if (GoodArgs(args, 2, "eGetSmPluginStatus <var> <plugin.smx>"))
	{
		new Handle:var = GetVarHandleFromArgNum(1, "0");
		if (var != INVALID_HANDLE)
		{
			decl String:plugin_name[125];
			GetCmdArg(2, plugin_name, 125);
			if (StrContains(plugin_name, ".smx") != -1 && FindPluginByFile(plugin_name) != INVALID_HANDLE) SetConVarInt(var, 1);
			else SetConVarInt(var, 0);
		}
	}
	return Plugin_Handled;
}

/// eHookConVarChange|eUnhookConVarChange

public Action:eHookConVar(args)
{
	decl String:Hook_CmD[35];
	GetCmdArg(0, Hook_CmD, 35);
	if (args != 1)
	{
		LogError("Syntax: %s <server_var>", Hook_CmD);
		return Plugin_Handled;
	}
	new Handle:var = GetVarHandleFromArgNum(1, "", true);
	if (var != INVALID_HANDLE)
	{
		if (StrEqual(Hook_CmD, "eHookConVarChange", false)) HookConVarChange(var, cVarChanged);
		else UnhookConVarChange(var, cVarChanged);
	}
	return Plugin_Handled;
}

public cVarChanged(Handle:var, const String:OldValue[], const String:NewValue[])
{
	new Handle:event = CreateEvent("es_cvar_changed");
	if (event == INVALID_HANDLE)
	{
		LogError("es_cvar_changed INVALID_HANDLE");
		return;
	}
	decl String:cvarname[75];
	cvarname[0] = '\0';
	GetConVarName(var, cvarname, 75);
	SetEventString(event, "cvarname", cvarname);
	SetEventString(event, "oldvalue", OldValue);
	SetEventString(event, "newvalue", NewValue);
	FireEvent(event);
}

public Action:eHideEntityFromPlayer(args)
{
	if (SDKHooksStatus == 1 && GoodArgs(args, 3, "eHideEntityFromPlayer <userid> <entity_index> <1=hide|0>"))
	{
		new client = GetClientFromArgNum(1);
		if (client > 0)
		{
			new index = GetIntFromArgNum(2);
			if (index > 0 && index <= MAX_ENTS && IsValidEntity(index))
			{
				if (GetIntFromArgNum(3) == 1)
				{
					if (!IndexHiddenForClient[index][client])
					{
						IndexHiddenForClient[index][client] = true;
						if (TransmitEntityClientsNum[index]++ < 1) SDKHook(index, SDKHook_SetTransmit, OnSetTransmit);
					}
				}
				else if (IndexHiddenForClient[index][client])
				{
					IndexHiddenForClient[index][client] = false;
					if (--TransmitEntityClientsNum[index] < 1) SDKUnhook(index, SDKHook_SetTransmit, OnSetTransmit);
				}
			}
		}
	}
	return Plugin_Handled;
}

public Action:OnSetTransmit(index, client)
{
	if (client > 0 && client <= MaxClients && IndexHiddenForClient[index][client]) return Plugin_Handled;
	return Plugin_Continue;
}

public OnEntityDestroyed(index)
{
	new Handle:event = CreateEvent("es_entity_destroyed");
	if (event == INVALID_HANDLE) LogError("es_entity_destroyed INVALID_HANDLE");
	else
	{
		SetEventInt(event, "entity_index", index);
		FireEvent(event);
	}
	if (index > 0 && index <= MAX_ENTS && TransmitEntityClientsNum[index] > 0)
	{
		TransmitEntityClientsNum[index] = 0;
		for (new client = 1; client <= MaxClients; client++) IndexHiddenForClient[index][client] = false;
	}
}

public OnClientDisconnect(client)
{
	if (SDKHooksStatus == 1)
	{
		for (new index = 1; index <= MAX_ENTS; index++) IndexHiddenForClient[index][client] = false;
	}
}

public Action:eUnHideEntity(args)
{
	if (SDKHooksStatus == 1 && GoodArgs(args, 1, "eUnHideEntity <entity_index>"))
	{
		new index = GetIntFromArgNum(1);
		if (index > 0 && index <= MAX_ENTS && TransmitEntityClientsNum[index] > 0 && IsValidEntity(index))
		{
			SDKUnhook(index, SDKHook_SetTransmit, OnSetTransmit);
			TransmitEntityClientsNum[index] = 0;
			for (new client = 1; client <= MaxClients; client++) IndexHiddenForClient[index][client] = false;
		}
	}
	return Plugin_Handled;
}

public OnEntityCreated(entity, const String:classname[])
{
	new Handle:event = CreateEvent("es_entity_created");
	if (event == INVALID_HANDLE)
	{
		LogError("es_entity_created INVALID_HANDLE");
		return;
	}
	SetEventInt(event, "entity_index", entity);
	SetEventString(event, "entity_class", classname);
	FireEvent(event);
}

public Action:eStartTouch(args)
{
	if (SDKHooksStatus == 1)
	{
		decl String:Hook_CmD[35];
		GetCmdArg(0, Hook_CmD, 35);
		if (args != 1)
		{
			LogError("Syntax: %s <entity_index>", Hook_CmD);
			return Plugin_Handled;
		}
		new index = GetIntFromArgNum(1);
		if (index > 0 && IsValidEntity(index))
		{
			SDKUnhook(index, SDKHook_StartTouch, OnStartTouch);
			if (StrEqual(Hook_CmD, "eHookStartTouch", false)) SDKHook(index, SDKHook_StartTouch, OnStartTouch);
		}
	}
	return Plugin_Handled;
}

public OnStartTouch(entity, client)
{
	if (client > 0 && client <= MaxClients)
	{
		new Handle:event = CreateEvent("es_start_touch");
		if (event == INVALID_HANDLE) LogError("es_start_touch INVALID_HANDLE");
		else
		{
			SetEventInt(event, "entity_index", entity);
			SetEventInt(event, "userid", GetClientUserId(client));
			decl String:class[55];
			class[0] = '\0';
			GetEntityClassname(entity, class, 55);
			SetEventString(event, "entity_class", class);
			FireEvent(event);
		}
	}
}

////////////////////////
/// *** FUNCTIONS ***

bool:GoodArgs(args, need_args, const String:msg[])
{
	if (args != need_args)
	{
		LogError("Syntax: %s", msg);
		return false;
	}
	return true;
}

GetClientFromArgNum(ArgNum)
{
	decl String:value[15];
	GetCmdArg(ArgNum, value, 15);
	new client = GetClientOfUserId(StringToInt(value));
	if (client < 1) LogError("More_ES_Commands: UserId: < %s > Not Found", value);
	return client;
}

GetIntFromArgNum(ArgNum)
{
	decl String:value[15];
	GetCmdArg(ArgNum, value, 15);
	return StringToInt(value);
}

Handle:GetVarHandleFromArgNum(ArgNum, const String:DefValue[] = "", bool:need_found = false)
{
	decl String:value[55];
	GetCmdArg(ArgNum, value, 55);
	new Handle:var = need_found ? FindConVar(value) : CreateConVar(value, DefValue);
	if (var == INVALID_HANDLE) LogError("More_ES_Commands: variable < %s > does not exist", value);
	return var;
}

/// by wS (Schmidt) # World-Source.Ru